/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

"use strict";

ChromeUtils.import("resource://gre/modules/XPCOMUtils.jsm");
ChromeUtils.defineModuleGetter(this, "Services", "resource://gre/modules/Services.jsm");
ChromeUtils.defineModuleGetter(this, "AddonManager", "resource://gre/modules/AddonManager.jsm");

this.EXPORTED_SYMBOLS = ["AppConstants"];

// Immutable for export.
this.AppConstants = Object.freeze({
  // See this wiki page for more details about channel specific build
  // defines: https://wiki.mozilla.org/Platform/Channel-specific_build_defines
  NIGHTLY_BUILD:
//@line 23 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 25 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  RELEASE_OR_BETA:
//@line 28 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 32 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  EARLY_BETA_OR_EARLIER:
//@line 37 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 39 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  ACCESSIBILITY:
//@line 42 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 46 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  // Official corresponds, roughly, to whether this build is performed
  // on Mozilla's continuous integration infrastructure. You should
  // disable developer-only functionality when this flag is set.
  MOZILLA_OFFICIAL:
//@line 52 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 56 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_OFFICIAL_BRANDING:
//@line 59 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 63 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_DEV_EDITION:
//@line 68 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 70 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_SERVICES_HEALTHREPORT:
//@line 75 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 77 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_DATA_REPORTING:
//@line 82 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 84 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_SANDBOX:
//@line 87 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 91 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_CONTENT_SANDBOX:
//@line 94 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 98 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_REPORTING:
//@line 103 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 105 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_ON_BY_DEFAULT:
//@line 110 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 112 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_UPDATER:
//@line 117 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 119 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_SWITCHBOARD:
//@line 124 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 126 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_WEBRTC:
//@line 129 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 133 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_WIDGET_GTK:
//@line 136 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 140 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  XP_UNIX:
//@line 143 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 147 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

//@line 150 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  platform:
//@line 152 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  "linux",
//@line 164 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  isPlatformAndVersionAtLeast(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) >= 0;
  },

  isPlatformAndVersionAtMost(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) <= 0;
  },

  MOZ_CRASHREPORTER:
//@line 181 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 183 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_MAINTENANCE_SERVICE:
//@line 188 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 190 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  DEBUG:
//@line 195 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 197 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  ASAN:
//@line 202 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 204 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_GRAPHENE:
//@line 209 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 211 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_SYSTEM_NSS:
//@line 216 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 218 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_PLACES:
//@line 221 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 225 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_ADDON_SIGNING:
//@line 230 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 232 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_REQUIRE_SIGNING:
//@line 237 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 239 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  get MOZ_UNSIGNED_SCOPES() {
    let result = 0;
//@line 248 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
    return result;
  },

  MOZ_ALLOW_LEGACY_EXTENSIONS:
//@line 253 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 257 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MENUBAR_CAN_AUTOHIDE:
//@line 260 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 264 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  CAN_DRAW_IN_TITLEBAR:
//@line 267 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 271 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_HISTORY:
//@line 276 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 278 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_TOOLKIT_SEARCH:
//@line 281 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 285 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_GECKO_PROFILER:
//@line 288 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  true,
//@line 292 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_ACTIVITY_STREAM:
//@line 297 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 299 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_MOZILLA_ONLINE:
//@line 304 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  false,
//@line 306 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  DLL_PREFIX: "lib",
  DLL_SUFFIX: ".so",

  MOZ_APP_NAME: "thunderbird",
  MOZ_APP_VERSION: "60.8.0",
  MOZ_APP_VERSION_DISPLAY: "60.8.0",
  MOZ_BUILD_APP: "comm/mail",
  MOZ_MACBUNDLE_NAME: "Thunderbird.app",
  MOZ_UPDATE_CHANNEL: "default",
  INSTALL_LOCALE: "en-US",
  MOZ_WIDGET_TOOLKIT: "gtk3",
  ANDROID_PACKAGE_NAME: "org.mozilla.thunderbird",

  DEBUG_JS_MODULES: "",

  MOZ_BING_API_CLIENTID: "no-bing-api-clientid",
  MOZ_BING_API_KEY: "no-bing-api-key",
  MOZ_GOOGLE_LOCATION_SERVICE_API_KEY: "no-google-location-service-api-key",
  MOZ_GOOGLE_SAFEBROWSING_API_KEY: "no-google-safebrowsing-api-key",
  MOZ_MOZILLA_API_KEY: "no-mozilla-api-key",

  // URL to the hg revision this was built from (e.g.
  // "https://hg.mozilla.org/mozilla-central/rev/6256ec9113c1")
  // On unofficial builds, this is an empty string.
//@line 334 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
  SOURCE_REVISION_URL: "https://hg.mozilla.org/mozilla-unified/rev/eb76765892cfd646d3014e5f3b8df8c6753da2d2",

  HAVE_USR_LIB64_DIR:
//@line 340 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
    false,
//@line 342 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  HAVE_SHELL_SERVICE:
//@line 345 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
    true,
//@line 349 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

  MOZ_STYLO:
//@line 354 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"
    false,
//@line 356 "/usr/src/RPM/BUILD/thunderbird-60.8.0/toolkit/modules/AppConstants.jsm"

});
